/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Clase que contiene la logica para procesar los registros del archivo de Ventas-Vehículo

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha             Autor                       Descripcion
    1.0    17-Julio-2019     Héctor Figueroa             Creación
******************************************************************************* */

public with sharing class TAM_VehiculoPasoHandler extends TriggerHandler{

    private List<TAM_VehiculoPaso__c> ventasHList;
    private Map<Id,TAM_VehiculoPaso__c> mapVentas;
    private Map<String,Map<String,RecordType>> recordTypesMap;

    public TAM_VehiculoPasoHandler() {
        this.ventasHList = Trigger.new;
        this.mapVentas = (Map<Id,TAM_VehiculoPaso__c>) Trigger.newMap;
        this.recordTypesMap = Constantes.TIPOS_REGISTRO_DEVNAME_ID; 
    }

    public override void afterInsert(){
        validateRecords(ventasHList);
        eliminaRecords(mapVentas);
    }

    private void eliminaRecords(Map<Id,TAM_VehiculoPaso__c> mapVentas){
        System.debug('ENTRO A TAM_VehiculoPasoHandler eliminaRecords...');      
        Set<String> vines = new Set<String>();
        for(TAM_VehiculoPaso__c v: mapVentas.values()){
            vines.add(v.id);
        }
        if(vines.size()>0){
            List<TAM_VehiculoPaso__c> borrar = new List<TAM_VehiculoPaso__c>();
            for(TAM_VehiculoPaso__c v : [SELECT Id, Name FROM TAM_VehiculoPaso__c WHERE id IN :vines]){
                borrar.add(v);
            }
            System.debug('ENTRO A TAM_VehiculoServicioPaso_tgr_handler eliminaRecords borrar: ' + borrar);          
            if(borrar.size()>0){
                //delete borrar;                
                List<Database.DeleteResult> lDtbUpsRes = Database.delete(borrar, false);
                //Ve si hubo error
                for (Database.DeleteResult objDtbUpsRes : lDtbUpsRes){
                    if (!objDtbUpsRes.isSuccess())
                        System.debug('Error a la hora de eliminar el reg ' + objDtbUpsRes.getErrors()[0].getMessage()); 
                }//Fin del for para lDtbUpsRes
            }
        }
    }

    private void validateRecords(List<TAM_VehiculoPaso__c> vehiculoList){
        System.debug('ENTRO A TAM_VehiculoPasoHandler validateRecords vehiculoList: ' + vehiculoList);
        String sToyota = 'TOYOTA FINANCIAL SERVICES';
        String sToyotaCompleto = 'TOYOTA FINANCIAL SERVICES MEXICO SA DE CV';
        String sTAM_QTY = '1';

    try{
        System.debug('ENTRO A TAM_VehiculoPasoHandler validateRecords vehiculoList: ' + recordTypesMap.KeySet());       
        System.debug('ENTRO A TAM_VehiculoPasoHandler validateRecords vehiculoList: ' + recordTypesMap.Values());       
                
        Map<String, Account> dealers;
        System.debug(JSON.serialize(mapVentas));
        
        String VaRtAccRegPM = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Moral').getRecordTypeId();
        String VaRtAccRegPF = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Fisica').getRecordTypeId();
        String VaRtOppRegVCrm = Schema.SObjectType.Opportunity.getRecordTypeInfosByName().get('Ventas CRM').getRecordTypeId();      
        String VaRtContRegPF = Schema.SObjectType.Contact.getRecordTypeInfosByName().get('Contactos-Clientes').getRecordTypeId();       
        String VaRtProdReg = Schema.SObjectType.Product2.getRecordTypeInfosByName().get('Unidad').getRecordTypeId();
        String VaRtStdPriceBookIdReg;       
        String VaNameStdPriceBookIdReg;     
        //No es una prueba
        if (!Test.isRunningTest()){ 
            VaRtStdPriceBookIdReg =[Select p.Name, p.IsStandard, p.Id From Pricebook2 p where p.IsStandard = true].id;
            VaNameStdPriceBookIdReg = [Select p.Name, p.IsStandard, p.Id, IdExternoListaPrecios__c From Pricebook2 p where p.IsStandard = true].IdExternoListaPrecios__c;           
        }//Fin si !Test.isRunningTest()
        //Es una prueba 
        if (Test.isRunningTest()){
            VaRtStdPriceBookIdReg = Test.getStandardPricebookId();
            VaNameStdPriceBookIdReg = 'StandardPriceBook';
        }//Fin si Test.isRunningTest()
        String[] setMeses = new list<String>{'Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'}; 
                
        Map<String, Vehiculo__c> vines = new Map<String, Vehiculo__c>();
        Map<String, ColorExterno__c> coloresExt = new Map<String, ColorExterno__c>();        
        Map<String, ColorInterno__c> coloresInt = new Map<String, ColorInterno__c>();    
        Map<String, Product2> productos = new Map<String, Product2>();

        Map<String, SolicitudAutoDemo__c> autosDemo = new Map<String, SolicitudAutoDemo__c>();
        List<Movimiento__c> movimientos = new List<Movimiento__c>();

        Set<String> dealersCode = new Set<String>();                
            
        Set<String> setModelo = new Set<String>();
        map<String, Modelo__c> mapModelos = new map<String, Modelo__c>();

        Set<String> setColorExt = new Set<String>();
        map<String, ColorExterno__c> mapColorExt = new map<String, ColorExterno__c>();

        Set<String> setColorInt = new Set<String>();
        map<String, ColorInterno__c> mapColorInt = new map<String, ColorInterno__c>();

        Set<String> setIdDistribuidor = new Set<String>();
        map<String, Account> mapDistribuidores = new map<String, Account>();

        map<String, Account> mapClientesUps = new Map<String, Account>();
        Set<String> setIdCtesCreados = new Set<String>();       
        map<String, String> mapIdClientesId = new Map<String, String>();

        map<String, Contact> mapContactosUps = new Map<String, Contact>();
        Set<String> setIdContactCreados = new Set<String>();
        Set<String> setErroresContactosUps = new Set<String>();             
        map<String, String> mapIdContactosId = new Map<String, String>();
        
        map<String, String> mapVinOppIdExtCliente = new map<String, String>();
        Set<String> setErroresAccUps = new Set<String>();

        map<String, String> mapVinOppIdExtClienteContacto = new map<String, String>();
        Set<String> setErroresAccContactUps = new Set<String>();

        Set<String> setIdVines = new Set<String>();
        map<String, Opportunity> mapOppUps = new map<String, Opportunity>();
        Set<String> setErroresOppUps = new Set<String>();
        Set<String> setSuccesOppUps = new Set<String>();        
        map<String, Opportunity> mapVinOppIdUps = new map<String, Opportunity>();
        
        map<String, Opportunity> mapOppDistUps = new map<String, Opportunity>();        
        Set<String> setErroresDistUps = new Set<String>();
        Set<String> setSuccesDistUps = new Set<String>();       

        map<String, OpportunityLineItem> mapOppLinItmUps = new map<String, OpportunityLineItem>();
        Set<String> setErroresOppLinItmUps = new Set<String>();
        Set<String> setSuccesOppLinItmUps = new Set<String>();      
        map<String, String> mapVinOppLinItmUps = new map<String, String>();

        Set<String> setProduct2 = new Set<String>();
        Map<String, Product2> mapProduct2 = new Map<String, Product2>();

        Set<String> setNombreListaPrecios = new Set<String>();
        Map<String, String> mapListaPrecios = new Map<String, String>();

        Set<String> setIdNomLisPre = new Set<String>();
        Set<String> setIdNomLisPreStd = new Set<String>();      
        Map<String, PricebookEntry> mapPrecios = new Map<String, PricebookEntry>();
        Map<String, PricebookEntry> mapPricebookEntryStd = new Map<String, PricebookEntry>();        
        Set<String> setSuccesEntryStd = new Set<String>();
        
        Set<String> setErroresVehiUps = new Set<String>();
        Set<String> setSuccesVehiUps = new Set<String>();       
        Map<String, Vehiculo__c> mapVehiculoCons = new Map<String, Vehiculo__c>();

        Set<String> setErroresOppVehic = new Set<String>();
        Set<String> setSuccesOppVehic = new Set<String>();      
        Map<String, TAM_OportunidadVehiculo__c> mapTAMOportunidadVehiculoUps = new Map<String, TAM_OportunidadVehiculo__c>();

        Map<String, Map<String, String>> mapIdVehiculoSetIdCtes = new Map<String, Map<String, String>>();       
        Map<String, TAM_Propietario__c> mapTAMPropietarioUps = new Map<String, TAM_Propietario__c>();       
        Set<String> setErroresPropVehic = new Set<String>();
        Set<String> setSuccesPropVehic = new Set<String>();     

        Map<String, Movimiento__c> mapMovimientoUps = new Map<String, Movimiento__c>();
        Set<String> setErroresMovVehic = new Set<String>();
        Set<String> setSuccesMovVehic = new Set<String>();      

        Map<String, String> mapVidIdProd = new Map<String, String>();
        Map<String, String> mapIdAccountName = new Map<String, String>();

        Map<String, String> mapVinIdDealer = new Map<String, String>();

        System.debug('ENTRO A TAM_VehiculoPasoHandler validateRecords ANTES DE LA LISTA DE vehiculoList: ' + vehiculoList);                                             
        //Recorre la lista de reg que se estan nsertando
        for(TAM_VehiculoPaso__c v: vehiculoList){
            
            //Actualiza los VINES que vienen en el campo de la Opp
            setIdVines.add(v.Name);
            
            //Para obtener los modelos          
            if(v.TAM_IdModelo__c != null)
                setModelo.add(v.TAM_IdModelo__c);
            //Para obtener los Colores Internos             
            if(v.TAM_IdColorInt__c != null)
                setColorInt.add(v.TAM_IdColorInt__c.right(2));//Los ultimos 2 caracteres
            //Para obtener los Colores Externos             
            if(v.TAM_IdColorExt__c != null)
                setColorExt.add(v.TAM_IdColorExt__c.right(3));//Los ultimos 3 caracteres
            //Para obtener los datos de los distrubuidores
            if(v.TAM_IdDealerCode__c != null)
                setIdDistribuidor.add(v.TAM_IdDealerCode__c);
            //Para obtener los datos de los Productos en Product2
            if(v.TAM_IdModelo__c != null && v.TAM_YearModelo__c != null)
                setProduct2.add(v.TAM_IdModelo__c + '' + v.TAM_YearModelo__c);
            //Agrega el VIN al mapa de mapVidIdProd
            if (v.Name != null && v.TAM_IdModelo__c != null && v.TAM_YearModelo__c != null)
                mapVidIdProd.put(v.Name, v.TAM_IdModelo__c + '' + v.TAM_YearModelo__c);
            //Toma el VIN y la clave del Dealer y metelo en mapVinIdDealer 
            if (v.Name != null && v.TAM_IdDealerCode__c != null)
                mapVinIdDealer.put(v.Name, v.TAM_IdDealerCode__c);
                
            System.debug('EN validateRecords v.TAM_SaleDate__c: '+ v.TAM_SaleDate__c + ' length(): ' + v.TAM_SaleDate__c.length());             
            //Para obtener las listas de precios de acuerdo a le fecha de venta
            String sTAM_SaleDate = v.TAM_SaleDate__c != null ? ConvierteFechaAAAAMMDD(v.TAM_SaleDate__c.substring(0, 10)) : null;
            System.debug('EN validateRecords sTAM_SaleDate: '+ sTAM_SaleDate);
            Date dFechaVenta = sTAM_SaleDate != null ? Date.valueOf(sTAM_SaleDate) : Date.today(); 
            Integer iAnioFechaVenta = v.TAM_YearModelo__c != null ? Integer.valueOf(v.TAM_YearModelo__c) : dFechaVenta.year();
            Integer iMesFechaVenta = v.TAM_Month__c != null ? Integer.valueOf(v.TAM_Month__c) - 1 : dFechaVenta.month();
            //Mete el nombre de la lista de precios al set de setNombreListaPrecios 
            setNombreListaPrecios.add('VH-' + setMeses[iMesFechaVenta] + '-' + iAnioFechaVenta);
            
            String sIdProducto = v.TAM_IdModelo__c + '' + v.TAM_YearModelo__c;
            String sNomLisPrec = 'VH-' + setMeses[iMesFechaVenta] + '-' + iAnioFechaVenta;
            
            setIdNomLisPre.add(sIdProducto + '-' + sNomLisPrec);
            setIdNomLisPreStd.add(sIdProducto + '-' + VaNameStdPriceBookIdReg);
                        
        }
        System.debug('EN validateRecords setNombreListaPrecios: '+ setNombreListaPrecios);
        System.debug('EN validateRecords setIdNomLisPre: '+ setIdNomLisPre);
        System.debug('EN validateRecords setIdNomLisPreStd: '+ setIdNomLisPreStd);
        System.debug('EN validateRecords mapVinIdDealer: '+ mapVinIdDealer.KeySet());
        System.debug('EN validateRecords mapVinIdDealer: '+ mapVinIdDealer.Values());           
        System.debug('EN validateRecords setColorInt: '+ setColorInt);
        System.debug('EN validateRecords setColorExt: '+ setColorExt);
        System.debug('EN validateRecords setProduct2: '+ setProduct2);
                                            
        //Consulta todos los modelos de 
        for (Modelo__c Modelo : [Select m.Name, m.Id, m.ID_Modelo__c From Modelo__c m
                Where ID_Modelo__c IN :setModelo]){
            mapModelos.put(Modelo.ID_Modelo__c, Modelo);
        }

        //Consulta todos los colores externos 
        for (ColorExterno__c ColExt : [Select c.Name, c.Id, c.CodigoColor__c From ColorExterno__c c
                Where CodigoColor__c IN :setColorExt]){
            mapColorExt.put(ColExt.CodigoColor__c, ColExt);
        }
        System.debug('EN validateRecords mapColorExt: ' + mapColorExt.keySet() + ' ' + mapColorExt.values());
        
        //Consulta todos los colores internos 
        for (ColorInterno__c ColInt : [Select c.Name, c.Id, c.CodigoColor__c From ColorInterno__c c
                Where CodigoColor__c IN :setColorInt]){
            mapColorInt.put(ColInt.CodigoColor__c, ColInt);
        }
        System.debug('EN validateRecords mapColorInt: ' + mapColorInt.keySet() + ' ' + mapColorInt.values());
        
        //Consulta todos los colores internos 
        for (Account Cliente : [Select c.Name, c.Id, c.Codigo_Distribuidor__c  From Account c
                Where Codigo_Distribuidor__c IN :setIdDistribuidor]){
            mapDistribuidores.put(Cliente.Codigo_Distribuidor__c, Cliente);
        }

        //Consulta todos los productos 
        for (Product2 Producto : [Select p.Id, p.NombreVersion__c, p.Name, p.IdExternoProducto__c, p.Anio__c 
                From Product2 p where RecordTypeId = :VaRtProdReg And IdExternoProducto__c IN :setProduct2]){
            mapProduct2.put(Producto.IdExternoProducto__c, Producto);
        }
        
        
        //****Consulta colores externos 
        for (ColorExterno__c ColExt : [Select c.Name, c.Id, c.CodigoColor__c From ColorExterno__c c
            Where CodigoColor__c IN :setColorExt]){
            coloresExt.put(ColExt.CodigoColor__c, ColExt);
        }
        System.debug('EN validateRecords coloresExt: ' + coloresExt);        
        //Crear color externos faltantes
        List<ColorExterno__c> listColorExt = new List<ColorExterno__c>();
        for(String colorExtNuevo : setColorExt){
            if(!coloresExt.containsKey(colorExtNuevo.right(3))){
                ColorExterno__c colorExtNew = new ColorExterno__c();
                colorExtNew.CodigoColor__c = colorExtNuevo.right(3);
                colorExtNew.Name = 'Por definir';
                colorExtNew.Descripcion__c = 'Por definir';
                listColorExt.add(colorExtNew);
            } //Fin si !coloresExt.containsKey(colorExtNuevo.right(3))
        }//Fin del for para ColorExt
        System.debug('EN validateRecords listColorExt: ' + listColorExt);
                        
        //Consulta colores internos 
        for (ColorInterno__c ColInt : [Select c.Name, c.Id, c.CodigoColor__c From ColorInterno__c c
            Where CodigoColor__c IN :setColorInt]){
            coloresInt.put(ColInt.CodigoColor__c, ColInt);
        }
        System.debug('EN validateRecords coloresInt: ' + coloresInt);        
        //Crear color internos faltantes
        List<ColorInterno__c> listColorInt = new List<ColorInterno__c>();
        for(String colorIntNuevo : setColorInt){
            if(!coloresInt.containsKey(colorIntNuevo.right(3))){
                ColorInterno__c colorIntNew = new ColorInterno__c();
                colorIntNew.CodigoColor__c = colorIntNuevo.right(2);
                colorIntNew.Name = 'Por definir';
                colorIntNew.Descripcion__c = 'Por definir';
                listColorInt.add(colorIntNew);
            } //Fin si !coloresInt.containsKey(colorIntNuevo.right(3))
        }//Fin del for para ColorInt
        System.debug('EN validateRecords listColorInt: ' + listColorInt);
                
        //Ve si es una pruba no actulice
        if (!Test.isRunningTest())
            if(!listColorExt.isEmpty())
                upsert listColorExt CodigoColor__c;            

        //Ve si es una pruba no actulice
        if (!Test.isRunningTest())
            if(!listColorInt.isEmpty())
                upsert listColorInt CodigoColor__c;

        //Llenar el mapa coloresExt para asociar los colores al VIN
        for(ColorExterno__c colorNuevosExt : listColorExt){
            coloresExt.put(colorNuevosExt.CodigoColor__c, colorNuevosExt);
            System.debug('EN validateRecords coloresExt: ' + coloresExt);            
        }
        
        //Llenar el mapa coloresInt para asociar los colores al VIN
        for(ColorInterno__c colorNuevosInt : listColorInt){
            coloresInt.put(colorNuevosInt.CodigoColor__c, colorNuevosInt);
            System.debug('EN validateRecords coloresInt: ' + coloresInt);            
        }
        //****Hasta aqui para la Consulta colores externos

        //Consulta todos los productos 
        for (Pricebook2 ListaPrecios : [Select p.Name, p.IsStandard, p.Id From Pricebook2 p 
                Where Name IN :setNombreListaPrecios order by Name]){
            mapListaPrecios.put(ListaPrecios.Name, ListaPrecios.id);
        }
        System.debug('EN validateRecords mapListaPrecios: ' + mapListaPrecios.keySet() + ' ' + mapListaPrecios.values());
        
        //Cconsulta los precios asociados a las lista de precios 
        for (PricebookEntry precio : [Select p.PrecioTotalEmpleado__c, p.PrecioSinIva__c, p.PrecioPublico__c, p.Name, 
                p.IdExterno__c, p.Id, p.Pricebook2Id From PricebookEntry p 
                where p.Pricebook2.IsActive = true AND (p.IdExterno__c IN :setIdNomLisPre 
                OR IdExterno__c IN :setIdNomLisPreStd)]){
            System.debug('EN validateRecords precios.IdExterno__c: '+ precio.IdExterno__c + ' ' + precio);
            //Agregalo al mapa de mapPrecios            
            mapPrecios.put(precio.IdExterno__c, precio);
        }
        System.debug('EN validateRecords mapPrecios: ' + mapPrecios.keySet() + ' ' + mapPrecios.values());
        
        //Recorre la lista de productos de la lista de precios estandar
        for (String setIdNomLisPreStdPaso : setIdNomLisPreStd){
            //Ve si no existe en mapPrecios
            if (!mapPrecios.containsKey(setIdNomLisPreStdPaso)){
                String sIdProd = setIdNomLisPreStdPaso.contains('-') ? setIdNomLisPreStdPaso.substring(0,setIdNomLisPreStdPaso.indexOf('-')) : null;
                System.debug('EN validateRecords sIdProd: ' + sIdProd);                 
                //Crea el reg de en la lista de precios estandar para setIdNomLisPreStdPaso
                PricebookEntry objPricebookEntry;
                objPricebookEntry = new PricebookEntry(IdExterno__c = setIdNomLisPreStdPaso);
                //Termina de inicializar los campos
                objPricebookEntry.Pricebook2Id = VaRtStdPriceBookIdReg;
                objPricebookEntry.Product2Id = mapProduct2.containsKey(sIdProd) ? mapProduct2.get(sIdProd).id : null;
                objPricebookEntry.UnitPrice = 0.0;
                objPricebookEntry.IsActive = true;
                mapPricebookEntryStd.put(VaRtStdPriceBookIdReg, objPricebookEntry);
            } //Fin si !mapPrecios.containsKey(setIdNomLisPreStdPaso)
        }//Fin del for setIdNomLisPreStd
        System.debug('En mapWrpPricebookEntry mapPricebookEntryStd: ' + mapPricebookEntryStd);
        
        //Ve si tiene algo la lista de mapPricebookEntryStd
        if (!mapPricebookEntryStd.isEmpty()){
            List<Database.UpsertResult> lDtbUpsRes = Database.upsert(mapPricebookEntryStd.values(), PricebookEntry.id, false);
            //Ve si hubo errores
            for (Database.UpsertResult objDtbUpsRes : lDtbUpsRes){
                if (!objDtbUpsRes.isSuccess())
                    System.debug('Error a la hora de actualizar la lista de precios estandard: ' + objDtbUpsRes.getErrors()[0].getMessage());
                if (objDtbUpsRes.isSuccess())
                    setSuccesEntryStd.add(objDtbUpsRes.getId());                    
            }//Fin del for para lDtbUpsRes          
        } //Fin si !mapWrpProducto.isEmpty()
        System.debug('En mapWrpPricebookEntry setSuccesEntryStd: ' + setSuccesEntryStd);
        
        //Cconsulta los precios asociados a las lista de precios 
        for (PricebookEntry precio : [Select p.PrecioTotalEmpleado__c, p.PrecioSinIva__c, p.PrecioPublico__c, p.Name, 
                p.IdExterno__c, p.Id, p.Pricebook2Id From PricebookEntry p 
                where p.id IN :setSuccesEntryStd]){
            System.debug('EN validateRecords precios.IdExterno__c2: '+ precio.IdExterno__c + ' ' + precio);
            //Agregalo al mapa de mapPrecios            
            mapPrecios.put(precio.IdExterno__c, precio);
        }
        System.debug('EN validateRecords mapPrecios2: ' + mapPrecios.keySet() + ' ' + mapPrecios.values());
        System.debug('EN validateRecords mapPrecios2: ' + mapPrecios.keySet() + ' ' + mapPrecios.values());
        
        Map<String, String> mapIdGrupoNombre = new Map<String, String>();       
        for (Group grupoPublico : [Select g.Name, g.Id From Group g
                where Name LIKE : '%TOYOTA%']){
            mapIdGrupoNombre.put(grupoPublico.Name, grupoPublico.id);
        }       
        System.debug('EN validateRecords mapIdGrupoNombre: ' + mapIdGrupoNombre.keySet() + ' ' + mapIdGrupoNombre.values());

        Map<String, String> mapIdUserGestor = new Map<String, String>();                
        for (User usuario : [SELECT Id, Name, Distribuidor__c, CodigoDistribuidor__c,Owner_Candidatos__c,
            Account.TAM_GestorLeads__c
            FROM User WHERE (accountid !='' AND Owner_Candidatos__c = true AND CodigoDistribuidor__c !='')
            And CodigoDistribuidor__c IN :mapDistribuidores.KeySet() And Account.TAM_GestorLeads__c != null
            And IsActive = true
            Order by CodigoDistribuidor__c]){
            //Agrega los datos a mapIdUserGestor
            mapIdUserGestor.put(usuario.CodigoDistribuidor__c, usuario.Account.TAM_GestorLeads__c);
        }
        System.debug('EN validateRecords mapIdUserGestor: ' + mapIdUserGestor.keySet() + ' ' + mapIdUserGestor.values());
        
        List<OpportunityShare> lOpportunityShare = new List<OpportunityShare>();
        List<AccountShare> lAccountShare = new List<AccountShare>();        
        //Consulta las opp creadas y mete la info a un mapa de 
        for (Opportunity OppUps : [Select id, TAM_Vin__c, Account.TAM_IdExternoNombre__c, Pricebook2Id, TAM_IdExterno__c,
            AccountId From Opportunity Where TAM_Vin__c IN: setIdVines]){
            mapVinOppIdUps.put(OppUps.TAM_Vin__c, OppUps);
            //Actualiza el campo del distrubuidor antes de meter la opp al mapa de mapVinOppIdUps
            String sIdealer = mapVinIdDealer.containsKey(OppUps.TAM_Vin__c) ? mapVinIdDealer.get(OppUps.TAM_Vin__c) : null;  
            //Crea la lista con las opp que tienes que actualizar antes que nada para el distrubiudor           
            mapOppDistUps.put(OppUps.TAM_IdExterno__c, new Opportunity(
                    id = OppUps.id,
                    TAM_Distribuidor__c = mapDistribuidores.containsKey(sIdealer) ? mapDistribuidores.get(sIdealer).id : null
                )
            );
            //Inicializa el Nombre del Dealer           
            String sDealerName = mapDistribuidores.containsKey(sIdealer) ? mapDistribuidores.get(sIdealer).Name.toUpperCase() : null;
            System.debug('EN CONSULTA OPP sDealerName: ' + sDealerName);

            //Crea la colaboración para las Opp relacionadas            
            lOpportunityShare.add(new OpportunityShare(
                    OpportunityId = OppUps.id,
                    UserOrGroupId = mapIdGrupoNombre.get(sDealerName),
                    OpportunityAccessLevel = 'Read'
                )
            );
            
            //Crea la colaboración para las cuetas a partir del Dealer
            lAccountShare.add(new AccountShare(
                    AccountId = OppUps.AccountId,
                    AccountAccessLevel = 'Read',
                    CaseAccessLevel = 'None',
                    OpportunityAccessLevel = 'None',
                    UserOrGroupId = mapIdGrupoNombre.get(sDealerName)
                )
            );          
            
        }
        System.debug('EN validateRecords mapVinOppIdUps: ' + mapVinOppIdUps.keySet() + ' ' + mapVinOppIdUps.values());
        System.debug('EN validateRecords mapOppDistUps: ' + mapOppDistUps.keySet() + ' ' + mapOppDistUps.values());
        System.debug('EN validateRecords lOpportunityShare: ' + lOpportunityShare);         
        System.debug('EN validateRecords lAccountShare: ' + lAccountShare);         

        //Recorre la lista de reg vehiculoList
        for(TAM_VehiculoPaso__c v: vehiculoList){
            if(v.TAM_IdDealerCode__c != null){
                dealersCode.add(v.TAM_IdDealerCode__c);
            } 
            
            if(v.Name != null){
                if(!vines.containsKey(v.Name)){
                    
                    String sTAMFechaEnvio = ConvierteFechaFechHora(v.TAM_SubmittedDate__c, v.TAM_SubmittedTime__c);
                    String sIdProdcto;
                    if(v.TAM_IdModelo__c != null && v.TAM_YearModelo__c != null)
                        sIdProdcto = v.TAM_IdModelo__c + '' + v.TAM_YearModelo__c;
                    System.debug('EN validateRecords sTAMFechaEnvio: '+ sTAMFechaEnvio + ' ' + sIdProdcto);

                    System.debug('EN validateRecords v.TAM_IdColorExt__c: '+ v.TAM_IdColorExt__c + ' v.TAM_IdColorInt__c: ' + v.TAM_IdColorInt__c);                                     
                    vines.put(v.Name, new Vehiculo__c(
                        Name = v.Name,
                        AnioModel__c = v.TAM_YearModelo__c,
                        Id_Externo__c = v.Name,
                        EstatusVINAutoDemo__c = 'H',                        
                        RecordTypeId = recordTypesMap.get('Vehiculo__c').get('Vehiculo').Id,
                        //Se agregan estos campos al objeto de Vehiculo__c ***YA NO SE PROCESA DEDESDE AQUI*** 
                        Modelo_b__c = mapModelos.containsKey(v.TAM_IdModelo__c) ? mapModelos.get(v.TAM_IdModelo__c).id : null,
                        Producto__c = mapProduct2.containsKey(sIdProdcto) ? mapProduct2.get(sIdProdcto).id : null,
                        TAM_SERIAL__c = v.TAM_Serial__c,
                        DescripcinColorExterno__c = v.TAM_DescrColorExt__c,                        
                        TAM_FechaEnvio__c = DateTime.valueOf(sTAMFechaEnvio),
                        ColorExternoVehiculo__c = mapColorExt.containsKey(v.TAM_IdColorExt__c.right(3)) ? mapColorExt.get(v.TAM_IdColorExt__c.right(3)).id : null,
                        ColorInternoVehiculo__c = mapColorInt.containsKey(v.TAM_IdColorInt__c.right(2)) ? mapColorInt.get(v.TAM_IdColorInt__c.right(2)).id : null
                    ));
                }                
            }
            
            if(v.TAM_IdModelo__c != null){
                if(!productos.containsKey(v.TAM_IdModelo__c)){
                    productos.put(v.TAM_IdModelo__c, new Product2(
                        Name = v.TAM_IdModelo__c,
                        IdExternoProducto__c = v.TAM_IdModelo__c + v.TAM_YearModelo__c,
                        IsActive = true,
                        RecordTypeId = recordTypesMap.get('Product2').get('Unidad').Id,
                        Family = Test.isRunningTest() ? 'Toyota' : 'Toyota',
                        Anio__c = Test.isRunningTest() ? '2018' : v.TAM_YearModelo__c
                    ));
                }
            }
            
        }
        
        System.debug(dealersCode);
        dealers = AutoDemoTriggerMethods.getDealerCodeInfoMap(dealersCode);
        System.debug(JSON.serialize(dealers));

        //Inicializa un SavePoint para hacer el rollback en caso de error
        SavePoint svUpsDatos = Database.setSavepoint();

        //Un try para los errores
        try{
            
            System.debug('EN validateRecords productos: ' + productos);
            //Actualiza los productos
            if(productos.size() > 0){
                try{
                    upsert productos.values() IdExternoProducto__c;                
                }catch(Exception ex){
                    System.debug('Error upsert productos: '+ex.getMessage());
                }
            }//Fin si productos.size() > 0

            //Recorremos los reg de ventas
            for(TAM_VehiculoPaso__c v: vehiculoList){

                Boolean bPersonaMoral = false;
                String sLlaveCompuestaNombre = '';
                String[] sLlaveNombreCompuesto = new List<String>();

                //****** TODO ESTO PARA LOS DATOS DE LA OPOTUNIDAD ASOCIADA AL CLIENTE (Opportunity) *****///
                //Para obtener los datos de los Productos en Product2
                String sIdProducto = '';
                if(v.TAM_IdModelo__c != null && v.TAM_YearModelo__c != null)
                    sIdProducto = v.TAM_IdModelo__c + '' + v.TAM_YearModelo__c;             
                String sVersionProd = '';
                if (sIdProducto != null && sIdProducto != '')
                    sVersionProd = mapProduct2.containsKey(sIdProducto) ? (mapProduct2.get(sIdProducto).NombreVersion__c + ' - ' + v.TAM_YearModelo__c): v.TAM_Serial__c + ' - ' + v.TAM_YearModelo__c;
                System.debug('EN validateRecords sIdProducto: ' + sIdProducto + ' sVersionProd: ' + sVersionProd);
                                
                String sTAM_SaleDate = v.TAM_SaleDate__c != null ? ConvierteFechaAAAAMMDD(v.TAM_SaleDate__c.substring(0, 10)) : v.TAM_SaleDate__c;
                System.debug('EN validateRecords sTAM_SaleDate: ' + sTAM_SaleDate);
                                
                Date dFechaVenta = sTAM_SaleDate != null ? Date.valueOf(sTAM_SaleDate) : Date.today(); 
                Integer iAnioFechaVenta = v.TAM_YearModelo__c != null ? Integer.valueOf(v.TAM_YearModelo__c) : dFechaVenta.year();
                Integer iMesFechaVenta = v.TAM_Month__c != null ? Integer.valueOf(v.TAM_Month__c) - 1 : dFechaVenta.month();
                String sNombreListaPrecios = 'VH-' + setMeses[iMesFechaVenta] + '-' + iAnioFechaVenta;
                String sIdListaPrecios = mapListaPrecios.containsKey(sNombreListaPrecios) ? mapListaPrecios.get(sNombreListaPrecios) : VaRtStdPriceBookIdReg;
                
                String sIdProdListaPrec = sIdProducto + '-' + sNombreListaPrecios; 
                System.debug('EN validateRecords sIdProdListaPrec: ' + sIdProdListaPrec);               
                Decimal dPrecio = mapPrecios.containsKey(sIdProdListaPrec) ? mapPrecios.get(sIdProdListaPrec).PrecioPublico__c : 0.00;
                //****** HASTA AQUI TODO ESTO PARA LOS DATOS DE LA OPOTUNIDAD ASOCIADA AL CLIENTE (Opportunity) *****///
                
                //****** PARA LOS DATOS DEL PRODUCTOS ASOCIADO A LA OPOTUNIDAD (OpportunityLineItem) *****///
                //Crea el objeto del tipo OpportunityLineItem
                if (v.Name != null){
                    String sIdListPrecios = sIdProducto + '-' + VaNameStdPriceBookIdReg;
                    //String sIdPriceBookEntry = mapPrecios.containsKey(sIdProdListaPrec) ? mapPrecios.get(sIdProdListaPrec).id : (mapPrecios.containsKey(sIdListPrecios) ? mapPrecios.get(sIdListPrecios).id : null);
                    String sIdPriceBookEntry = mapPrecios.containsKey(sIdListPrecios) ? mapPrecios.get(sIdListPrecios).id : null;                   
                    //String sIdListaPecios = mapPrecios.containsKey(sIdProdListaPrec) ? mapPrecios.get(sIdProdListaPrec).Pricebook2Id : (mapPrecios.containsKey(sIdListPrecios) ? mapPrecios.get(sIdListPrecios).Pricebook2Id : null );
                    String sIdListaPecios = VaRtStdPriceBookIdReg;
                    System.debug('EN validateRecords sIdListPrecios: ' + sIdListPrecios + ' sIdPriceBookEntry: ' + sIdPriceBookEntry + ' sIdListaPecios: ' + sIdListaPecios);
                    //Ve si no tiene lista de precios entonces no crees el objeto
                    if ( (sIdPriceBookEntry != null && sIdListaPecios != null) || Test.isRunningTest()){
                        //Crea el objeto del tipo OpportunityLineItem 
                        OpportunityLineItem objOpportunityLineItemPaso = new OpportunityLineItem(
                            TAM_Vin__c = v.Name,
                            UnitPrice = dPrecio,
                            Product2Id = mapProduct2.containsKey(sIdProducto) ? mapProduct2.get(sIdProducto).ID : null,
                            Quantity = sTAM_QTY != null ? Integer.valueOf(sTAM_QTY) : 1,
                            PricebookEntryId = sIdPriceBookEntry,
                            TAM_IdExterno__c = v.Name + '-' + sIdListaPecios 
                        );
                        System.debug('EN validateRecords OpportunityLineItem: ' + objOpportunityLineItemPaso);
                        //Agrega la al mapa de mapOppLinItmUps 
                        mapOppLinItmUps.put(v.Name, objOpportunityLineItemPaso);
                    }//sIdPriceBookEntry != null
                }//Fin si v.Name != null
                //****** TODO ESTO PARA LOS DATOS DEL PRODUCTOS ASOCIADO A LA OPOTUNIDAD (OpportunityLineItem) *****///

            }//Fin del for para vehiculoList

            Integer icntUpsCtes = 0;
            //Antes que nada actualiza las oportunidades que vienen en el mapa de mapOppDistUps
            if (!mapOppDistUps.isEmpty()){
                List<Opportunity> lOppDistUps = mapOppDistUps.values();             
                //Actualiza las Opp 
                List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lOppDistUps, Opportunity.Id, false);
                //Ve si hubo error
                for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
                    if (!objDtbUpsRes.isSuccess()){
                        setErroresDistUps.add('En la Opp: ' + lOppDistUps.get(icntUpsCtes).TAM_Distribuidor__c + ' hubo error a la hora de crear/Actualizar el precio de lista de la Opp: ' + objDtbUpsRes.getErrors()[0].getMessage());
                        System.debug('En la Opp: ' + lOppDistUps.get(icntUpsCtes).TAM_Distribuidor__c + ' hubo error a la hora de crear/Actualizar el precio de lista de la Opp: ' + objDtbUpsRes.getErrors()[0].getMessage());
                    }
                    if (objDtbUpsRes.isSuccess()){
                        setSuccesDistUps.add(objDtbUpsRes.getId());
                        System.debug('EN validateRecords objDtbUpsRes.getId() Opportunity: ' + objDtbUpsRes.getId());                           
                    }
                    icntUpsCtes++;  
                }//Fin del for para lDtbUpsRes
            }//Fin si !mapOppDistUps.isEmpty()
            System.debug('EN validateRecords setErroresDistUps: ' + setErroresDistUps);
            System.debug('EN validateRecords setSuccesDistUps: ' + setSuccesDistUps);
            
            icntUpsCtes = 0;
            //Antes que nada actualiza las oportunidades que vienen en el mapa de mapOppDistUps
            /*if (!lOpportunityShare.isEmpty()){
                //Actualiza las Opp 
                List<Database.Saveresult> lDtbUpsRes = Database.insert(lOpportunityShare, false);
                //Ve si hubo error
                for (Database.Saveresult objDtbUpsRes : lDtbUpsRes){
                    if (!objDtbUpsRes.isSuccess()){
                        setErroresDistUps.add('En la OppSh: ' + lOpportunityShare.get(icntUpsCtes).OpportunityId + ' hubo error a la hora de crear/Actualizar el precio de lista de la Opp: ' + objDtbUpsRes.getErrors()[0].getMessage());
                        System.debug('En la OppSh: ' + lOpportunityShare.get(icntUpsCtes).OpportunityId + ' hubo error a la hora de crear/Actualizar el precio de lista de la Opp: ' + objDtbUpsRes.getErrors()[0].getMessage());
                    }
                    if (objDtbUpsRes.isSuccess()){
                        setSuccesDistUps.add(objDtbUpsRes.getId());
                        System.debug('EN validateRecords objDtbUpsRes.getId() Opportunity Share: ' + objDtbUpsRes.getId());                         
                    }
                    icntUpsCtes++;  
                }//Fin del for para lDtbUpsRes
            }//Fin si !lOpportunityShare.isEmpty()*/
            System.debug('EN validateRecords setErroresDistUps: ' + setErroresDistUps);
            System.debug('EN validateRecords setSuccesDistUps: ' + setSuccesDistUps);

            icntUpsCtes = 0;
            //Antes que nada actualiza las oportunidades que vienen en el mapa de mapOppDistUps
            if (!lAccountShare.isEmpty()){
                //Actualiza las Opp 
                List<Database.Saveresult> lDtbUpsRes = Database.insert(lAccountShare, false);
                //Ve si hubo error
                for (Database.Saveresult objDtbUpsRes : lDtbUpsRes){
                    if (!objDtbUpsRes.isSuccess()){
                        setErroresDistUps.add('En la AccSh: ' + lAccountShare.get(icntUpsCtes).AccountId + ' hubo error a la hora de crear/Actualizar el precio de lista de la Opp: ' + objDtbUpsRes.getErrors()[0].getMessage());
                        System.debug('En la AccSh: ' + lAccountShare.get(icntUpsCtes).AccountId + ' hubo error a la hora de crear/Actualizar el precio de lista de la Opp: ' + objDtbUpsRes.getErrors()[0].getMessage());
                    }
                    if (objDtbUpsRes.isSuccess()){
                        setSuccesDistUps.add(objDtbUpsRes.getId());
                        System.debug('EN validateRecords objDtbUpsRes.getId() AccSh: ' + objDtbUpsRes.getId());                         
                    }
                    icntUpsCtes++;  
                }//Fin del for para lDtbUpsRes
            }//Fin si !lAccountShare.isEmpty()
            System.debug('EN validateRecords setErroresDistUps: ' + setErroresDistUps);
            System.debug('EN validateRecords setSuccesDistUps: ' + setSuccesDistUps);

            System.debug('EN validateRecords mapOppLinItmUps: ' + mapOppLinItmUps.KeySet() + ' mapOppLinItmUps: ' + mapOppLinItmUps.values());
            //Ya tiens los datos de las Opp has el upsert con los datos de mapOppUps
            icntUpsCtes = 0;
            if (!mapOppLinItmUps.isEmpty()){
                //Inicializa una lista con las opp que se van a crear/Actualizar
                List<OpportunityLineItem> lOppLinItmUps = mapOppLinItmUps.values();
                //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
                for (OpportunityLineItem OppLinItm : lOppLinItmUps){
                    String sVin = OppLinItm.TAM_IdExterno__c.substring(0, OppLinItm.TAM_IdExterno__c.indexOf('-'));
                    String sPriceBook = OppLinItm.TAM_IdExterno__c.substring(OppLinItm.TAM_IdExterno__c.indexOf('-')  + 1 , OppLinItm.TAM_IdExterno__c.length());
                    //Ve si existe el VIN asociado a la OPP
                    if (mapVinOppIdUps.containsKey(sVin)){
                        String sIdPbeOpp = mapVinOppIdUps.get(sVin).Pricebook2Id;
                        //Actualiza los datos de OpportunityLineItem
                        OppLinItm.OpportunityId = mapVinOppIdUps.get(sVin).id;
                        OppLinItm.TAM_IdExterno__c = OppLinItm.TAM_IdExterno__c + '-' + OppLinItm.OpportunityId;
                        System.debug('EN validateRecords sVin: ' + sVin + ' sPriceBook: ' + sPriceBook + ' sIdPbeOpp: ' + sIdPbeOpp + ' OpportunityId: ' + OppLinItm.OpportunityId + ' TAM_IdExterno__c: ' + OppLinItm.TAM_IdExterno__c);                                               
                        //Ve si el ID de la lista de precioas : sPriceBook es igual al de la Opp
                        if ( (sPriceBook != sIdPbeOpp) || Test.isRunningTest()){
                            //Actualiza los datos de la Opp 
                            mapOppUps.put(OppLinItm.OpportunityId, new Opportunity(id = OppLinItm.OpportunityId,
                                    Pricebook2Id = sPriceBook 
                                )
                            ); 
                        }//Fin si sPriceBook != sIdPbeOpp
                    }//Fin si mapVinOppIdUps.containsKey(sVin)
                }//Fin del for para lOppLinItmUps
                System.debug('EN validateRecords mapOppUps: ' + mapOppUps);
                System.debug('EN validateRecords lOppLinItmUps: ' + lOppLinItmUps);
                                                
                //Ve si tiene algo el mapa de mapOppUps  y actueliza la lista de precios de la opp
                if (!mapOppUps.isEmpty()){
                    //Actualiza las Opp 
                    List<Database.Upsertresult> lDtbUpsRes = Database.upsert(mapOppUps.values(), Opportunity.Id, false);
                    //Ve si hubo error
                    for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
                        if (!objDtbUpsRes.isSuccess()){
                            setErroresOppUps.add('En la Opp: ' + lOppLinItmUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar el precio de lista de la Opp: ' + objDtbUpsRes.getErrors()[0].getMessage());
                            System.debug('En la Opp: ' + lOppLinItmUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar el precio de lista de la Opp: ' + objDtbUpsRes.getErrors()[0].getMessage());
                        }
                        if (objDtbUpsRes.isSuccess()){
                            setSuccesOppUps.add(objDtbUpsRes.getId());
                            System.debug('EN validateRecords objDtbUpsRes.getId() Opportunity: ' + objDtbUpsRes.getId());                           
                        }
                        icntUpsCtes++;  
                    }//Fin del for para lDtbUpsRes
                }//Fin si !mapOppUps.isEmpty()
                System.debug('EN validateRecords setErroresOppUps: ' + setErroresOppUps);
                System.debug('EN validateRecords setSuccesOppUps: ' + setSuccesOppUps);

                System.debug('EN validateRecords lOppLinItmUps: ' + lOppLinItmUps);                 
                icntUpsCtes = 0;                                
                //Actualiza las Opp 
                List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lOppLinItmUps, OpportunityLineItem.TAM_IdExterno__c, false);
                //Ve si hubo error
                for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
                    if (!objDtbUpsRes.isSuccess()){
                        setErroresOppLinItmUps.add('En la Opp Line Item: ' + lOppLinItmUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                        System.debug('En la Opp Line Item: ' + lOppLinItmUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                    }
                    if (objDtbUpsRes.isSuccess()){
                        setSuccesOppLinItmUps.add(objDtbUpsRes.getId());
                        System.debug('EN validateRecords objDtbUpsRes.getId() OpportunityLineItem: ' + objDtbUpsRes.getId());                       
                    }
                    icntUpsCtes++;  
                }//Fin del for para lDtbUpsRes
                
            }//Fin si mapOppLinItmUps.isEmpty()
            System.debug('EN validateRecords setErroresOppLinItmUps: ' + setErroresOppLinItmUps);           
            System.debug('EN validateRecords setSuccesOppLinItmUps: ' + setSuccesOppLinItmUps);
            
            //Consulta las opp creadas y mete la info a un mapa de 
            for (OpportunityLineItem OppLinItm : [Select id, TAM_IdExterno__c, OpportunityId, Opportunity.TAM_Vin__c
                From OpportunityLineItem Where id IN :setSuccesOppLinItmUps]){
                System.debug('EN validateRecords OppLinItm.TAM_IdExterno__c: ' + OppLinItm.TAM_IdExterno__c);                   
                //Toma solo el VIN del campo TAM_IdExterno__c
                String sIdVin = OppLinItm.TAM_IdExterno__c !=  null ? OppLinItm.TAM_IdExterno__c.substring(0, OppLinItm.TAM_IdExterno__c.indexOf('-')) : null;
                System.debug('EN validateRecords sIdVin: ' + sIdVin);
                if (sIdVin != null) 
                    mapVinOppLinItmUps.put(sIdVin, OppLinItm.OpportunityId);
            }
            System.debug('EN validateRecords mapVinOppLinItmUps: ' + mapVinOppLinItmUps.keySet() + ' ' + mapVinOppLinItmUps.values());                                  

            System.debug('EN validateRecords vines: ' + vines.keySet() + ' ' + vines.values());         
            //Actualiza los datos del Vehiculo
            if (!vines.isEmpty()){
                icntUpsCtes = 0;                
                List<Vehiculo__c> lVehiculosUps = vines.values();               
                List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lVehiculosUps, Vehiculo__c.Id_Externo__c, false);
                //Ve si hubo error
                for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
                    if (!objDtbUpsRes.isSuccess()){
                        setErroresVehiUps.add('En el Vehiculo: ' + lVehiculosUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                        System.debug('En el Vehiculo: ' + lVehiculosUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());                      
                    }
                    if (objDtbUpsRes.isSuccess()){
                        setSuccesVehiUps.add(objDtbUpsRes.getId());
                        System.debug('EN validateRecords objDtbUpsRes.getId() Vehiculo__c: ' + objDtbUpsRes.getId());                       
                    }
                    icntUpsCtes++;  
                }//Fin del for para lDtbUpsRes
            }//Fin si !vines.isEmpty()
            //Consulta los datos de los Vehiculos actualizados y toma el vin
            for (Vehiculo__c vehiculo : [Select id, Name, AnioModel__c, Id_Externo__c, EstatusVINAutoDemo__c, RecordTypeId,
                Modelo_b__c, TAM_SERIAL__c, ColorExternoVehiculo__c, DescripcinColorExterno__c, ColorInternoVehiculo__c, TAM_FechaEnvio__c       
                From Vehiculo__c Where id IN:setSuccesVehiUps] ){
                mapVehiculoCons.put(Vehiculo.Name, vehiculo);
            }
            System.debug('EN validateRecords setErroresVehiUps: ' + setErroresVehiUps + ' setSuccesVehiUps: ' + setSuccesVehiUps + ' mapVehiculoCons: ' + mapVehiculoCons.keySet() + ' mapVehiculoCons: ' + mapVehiculoCons.Values());          
                                    
            //Busca las Opp asociadas a mapVinOppLinItmUps.KeySet()
            if (!mapVinOppLinItmUps.isEmpty()){
                //Consulta las Opp asociadas a mapVinOppLinItmUps.values()
                for (Opportunity Opp : [Select id, TAM_Vin__c, AccountId, Account.Name From Opportunity Where Id IN :mapVinOppLinItmUps.KeySet()]){
                    //Agregala al mapa de mapVinOppIdUps
                    if (Opp.TAM_Vin__c != null){
                        mapVinOppIdUps.put(Opp.TAM_Vin__c, Opp);
                        mapIdAccountName.put(Opp.AccountId, Opp.Account.Name);
                    }//Fin si Opp.TAM_Vin__c != null
                } //Fin del for para Opp 
            }//Fin si !mapVinOppLinItmUps.isEmpty()
            System.debug('EN validateRecords mapVinOppIdUps: ' + mapVinOppIdUps.KeySet() + ' mapVinOppIdUps: ' + mapVinOppIdUps.Values());          
            System.debug('EN validateRecords mapIdAccountName: ' + mapIdAccountName.KeySet() + ' mapIdAccountName: ' + mapIdAccountName.Values());
                        
            //Ya tienes los datos de los Vehiculos y las Opp entces crea la relacion en el objeto de TAM_OportunidadVehiculo__c
            //Map<String, TAM_OportunidadVehiculo__c> mapTAMOportunidadVehiculoUps = new Map<String, TAM_OportunidadVehiculo__c>();
            for (String sIdVinOpp : mapVinOppIdUps.KeySet()){
                System.debug('EN validateRecords sIdVinOpp: ' + sIdVinOpp);             
                //Ve si tiene algo el mapa de  mapVinOppIdUps y el del mapVehiculoCons
                if ( mapVinOppIdUps.containsKey(sIdVinOpp) && mapVehiculoCons.containsKey(sIdVinOpp) ){                 
                    String sIdExterOppVehic = mapVinOppIdUps.get(sIdVinOpp).id + '-' + mapVehiculoCons.get(sIdVinOpp).id;
                    System.debug('EN validateRecords sIdExterOppVehic: ' + sIdExterOppVehic);                   
                    String sIdProd = mapVidIdProd.get(mapVinOppIdUps.get(sIdVinOpp).TAM_Vin__c);
                    System.debug('EN validateRecords sIdProd: ' + sIdProd);
                    //Ve si existe el producto en mapProduct2
                    if (mapProduct2.containsKey(sIdProd) || Test.isRunningTest()){
                        String sVersion = mapProduct2.containsKey(sIdProd) ? mapProduct2.get(sIdProd).NombreVersion__c : '';
                        System.debug('EN validateRecords sVersion: ' + sVersion);                   
                        String sAnio = mapProduct2.containsKey(sIdProd) ? mapProduct2.get(sIdProd).Anio__c : '';
                        System.debug('EN validateRecords sAnio: ' + sAnio);                 
                        String sNameReg = mapVinOppIdUps.get(sIdVinOpp).TAM_Vin__c + '-' + sVersion + '-' + sAnio;
                        System.debug('EN validateRecords sIdExterOppVehic: ' + sIdExterOppVehic);                   
                        mapTAMOportunidadVehiculoUps.put(sIdExterOppVehic, new TAM_OportunidadVehiculo__c(
                                Name = sNameReg,
                                TAM_IdExterno__c = sIdExterOppVehic,
                                TAM_Oportunidad__c = mapVinOppIdUps.get(sIdVinOpp).id,
                                TAM_Vehiculo__c = mapVehiculoCons.get(sIdVinOpp).id
                            )
                        );
                    }//Fin si mapProduct2.containsKey(sIdProd)
                }//Fin mapVinOppIdUps.containsKey(sIdVinOpp) && mapVehiculoCons.containsKey(sIdVinOpp)
            }//Fin del for para mapVinOppIdUps.KeySet()
            System.debug('EN validateRecords mapTAMOportunidadVehiculoUps: ' + mapTAMOportunidadVehiculoUps.KeySet() + ' mapTAMOportunidadVehiculoUps: ' + mapTAMOportunidadVehiculoUps.values());
            
            //Ve si tiene algo el mapa de  mapTAMOportunidadVehiculoUps
            if (!mapTAMOportunidadVehiculoUps.isEmpty()){
                icntUpsCtes = 0;                
                List<TAM_OportunidadVehiculo__c> lOppVehicUps = mapTAMOportunidadVehiculoUps.values();              
                List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lOppVehicUps, TAM_OportunidadVehiculo__c.TAM_IdExterno__c, false);
                //Ve si hubo error
                for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
                    if (!objDtbUpsRes.isSuccess()){
                        setErroresOppVehic.add('En la relacion de Opp con Vehiculo: ' + lOppVehicUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                        System.debug('En la relacion de Opp con Vehiculo: ' + lOppVehicUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                    }
                    if (objDtbUpsRes.isSuccess()){
                        setSuccesOppVehic.add(objDtbUpsRes.getId());
                        System.debug('EN validateRecords objDtbUpsRes.getId() TAM_OportunidadVehiculo__c: ' + objDtbUpsRes.getId());                        
                    }
                    icntUpsCtes++;  
                }//Fin del for para lDtbUpsRes              
            }//Fin si !mapTAMOportunidadVehiculoUps.isEmpty()           
            System.debug('EN validateRecords setErroresOppVehic: ' + setErroresOppVehic + ' setSuccesOppVehic: ' + setSuccesOppVehic);          

            //Consulta los clientes asociados a setSuccesOppVehic en el objeto de TAM_OportunidadVehiculo__c  
            for (TAM_OportunidadVehiculo__c Opp : [Select id, TAM_Oportunidad__r.AccountId, TAM_Vehiculo__c,
                    TAM_Oportunidad__r.TAM_Vin__c, TAM_Oportunidad__r.Account.Name 
                    From TAM_OportunidadVehiculo__c Where Id IN :setSuccesOppVehic]){
                //Metelos al mapa de mapIdVehiculoSetIdCtes
                if (mapIdVehiculoSetIdCtes.containsKey(Opp.TAM_Vehiculo__c))
                    mapIdVehiculoSetIdCtes.get(Opp.TAM_Vehiculo__c).put(Opp.TAM_Oportunidad__r.AccountId, Opp.TAM_Oportunidad__r.TAM_Vin__c);
                if (!mapIdVehiculoSetIdCtes.containsKey(Opp.TAM_Vehiculo__c))
                    mapIdVehiculoSetIdCtes.put(Opp.TAM_Vehiculo__c, new Map<String, String>{Opp.TAM_Oportunidad__r.AccountId => Opp.TAM_Oportunidad__r.TAM_Vin__c});
                //Agrega los datos del cliente al mapa de mapIdAccountName
                mapIdAccountName.put(Opp.TAM_Oportunidad__r.AccountId, Opp.TAM_Oportunidad__r.Account.Name);                    
            } //Fin del for para Opp 
            System.debug('EN validateRecords mapIdVehiculoSetIdCtes: ' + mapIdVehiculoSetIdCtes.KeySet() + ' mapIdVehiculoSetIdCtes: ' + mapIdVehiculoSetIdCtes.Values());                      
            System.debug('EN validateRecords mapIdAccountName2: ' + mapIdAccountName.KeySet() + ' mapIdAccountName: ' + mapIdAccountName.Values());
                        
            //Ya tienes los datos de los propietarios de los vehiculos entonces actualizalos en TAM_Propietario__c
            for (String sIdVehiculo : mapIdVehiculoSetIdCtes.keySet()){
                //Recorre la lista de clientes que vienen en mapIdVehiculoSetIdCtes.get(sIdVehiculo)
                for (String sIdCliente : mapIdVehiculoSetIdCtes.get(sIdVehiculo).KeySet()){
                    //Crea la llave unica para actualiuzar los datos del propietario en base al vehiculo y a la cuenta
                    String sIdVehicCuenta = sIdVehiculo + '-' + sIdCliente;
                    String sNameReg = mapIdVehiculoSetIdCtes.get(sIdVehiculo).get(sIdCliente) + '-' + (mapIdAccountName.containsKey(sIdCliente) ? mapIdAccountName.get(sIdCliente) : ''); 
                    mapTAMPropietarioUps.put(sIdVehicCuenta, new TAM_Propietario__c(
                            Name = sNameReg, 
                            TAM_IdExterno__c = sIdVehicCuenta,
                            TAM_Vin__c = mapIdVehiculoSetIdCtes.get(sIdVehiculo).get(sIdCliente),
                            TAM_Cliente__c = sIdCliente,
                            TAM_Vehiculo__c = sIdVehiculo,
                            TAM_Actual__c = true  
                        )
                    );
                }//Fin del for para mapIdVehiculoSetIdCtes.get(sIdVehiculo)
            }//Fin del for para la lista de sIdVehiculo 
            System.debug('EN validateRecords mapTAMPropietarioUps: ' + mapTAMPropietarioUps.KeySet() + ' mapTAMPropietarioUps: ' + mapTAMPropietarioUps.Values());
                        
            //Ve si tiene algo el mapa de  mapTAMPropietarioUps
            if (!mapTAMPropietarioUps.isEmpty()){
                icntUpsCtes = 0;                
                List<TAM_Propietario__c> lPropUps = mapTAMPropietarioUps.values();              
                List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lPropUps, TAM_Propietario__c.TAM_IdExterno__c, false);
                //Ve si hubo error
                for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
                    if (!objDtbUpsRes.isSuccess()){
                        setErroresPropVehic.add('En la relacion de los Clientes con Vehiculo: ' + lPropUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                        System.debug('En la relacion de los Clientes con Vehiculo: ' + lPropUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                    }
                    if (objDtbUpsRes.isSuccess()){
                        setSuccesPropVehic.add(objDtbUpsRes.getId());
                        System.debug('EN validateRecords objDtbUpsRes.getId() TAM_Propietario__c: ' + objDtbUpsRes.getId());                        
                    }
                    icntUpsCtes++;  
                }//Fin del for para lDtbUpsRes              
            }//Fin si !mapTAMPropietarioUps.isEmpty()           
            System.debug('EN validateRecords setErroresPropVehic: ' + setErroresPropVehic + ' setSuccesPropVehic: ' + setSuccesPropVehic);
            
            //Un set para todos los vines asociados a setSuccesPropVehic
            Set<String> setVinProp = new Set<String>();
            Map<String, Map<String, TAM_Propietario__c>> mapVinMapIdExtProp = new Map<String, Map<String, TAM_Propietario__c>>();
            Map<String, Account> mapIdAccObjAccUps = new Map<String, Account>();
            Map<String, Contact> mapIdContactObjContUps = new Map<String, Contact>();               
            //Consulta los datos de los clientes que acaban de ser actualizaos en el objeto de TAM_Propietario__c
            for (TAM_Propietario__c properario : [Select id, TAM_Vin__c From TAM_Propietario__c
                Where TAM_Actual__c = true and ID IN : setSuccesPropVehic]){
                setVinProp.add(properario.TAM_Vin__c);
            }
            
            //Guarca las cuentas que se van a actuelizar para consultar sus contactos
            Set<String> setIdCliente = new Set<String>(); 
            //Ya tienes los Vines de los propietarios
            for (TAM_Propietario__c Cliente : [Select t.id, t.TAM_Vin__c, t.CreatedDate, TAM_IdExterno__c, TAM_Cliente__c,
                TAM_Cliente__r.TAM_IdExternoNombre__c, TAM_Cliente__r.ParentId, TAM_Cliente__r.BillingStreet,
                TAM_Cliente__r.Colonia__c, TAM_Cliente__r.BillingCity, TAM_Cliente__r.BillingState,
                TAM_Cliente__r.BillingPostalCode, TAM_Cliente__r.Phone, TAM_Cliente__r.Telefono_Oficina__c,
                TAM_Cliente__r.Extension_Oficina__c, TAM_Cliente__r.Correo_Electronico__c,
                TAM_Cliente__r.RFC__c, TAM_Cliente__r.RFC2__c, TAM_Cliente__r.recordTypeId,
                TAM_Cliente__r.Name, TAM_Cliente__r.FirstName, TAM_Cliente__r.LastName, TAM_Cliente__r.Apellido_Paterno__c                  
                From TAM_Propietario__c t
                Where t.TAM_Actual__c = true And TAM_Vin__c IN :setVinProp 
                Order by t.TAM_Vin__c, t.CreatedDate DESC]){

                //Ve si ya existe en mapVinMapIdExtProp             
                if (mapVinMapIdExtProp.containsKey(Cliente.TAM_Vin__c)){
                    mapVinMapIdExtProp.put(Cliente.TAM_Vin__c, new Map<String, TAM_Propietario__c>{Cliente.TAM_IdExterno__c => new TAM_Propietario__c(
                                id = Cliente.id, TAM_Actual__c = false
                            )
                        }
                    );
                }//Fin si mapVinMapIdExtProp.containsKey(Cliente.TAM_Vin__c)
                //Ve si no existe en mapVinMapIdExtProp
                if (!mapVinMapIdExtProp.containsKey(Cliente.TAM_Vin__c)){
                    mapVinMapIdExtProp.put(Cliente.TAM_Vin__c, new Map<String, TAM_Propietario__c>{Cliente.TAM_IdExterno__c => new TAM_Propietario__c(
                                id = Cliente.id, TAM_Actual__c = true                                   
                            )
                        }
                    );
                    //Agregalo al mapa de mapIdAccObjAccUps  
                    mapIdAccObjAccUps.put(Cliente.TAM_Vin__c, Cliente.TAM_Cliente__r);
                    //Agrega la cuenta al set de setIdCliente
                    setIdCliente.add(Cliente.TAM_Cliente__c);
                }//Fin si !mapVinMapIdExtProp.contaninsKey(Cliente.TAM_Vin__c)
            }//Fin del for para la consulta de los datos el cliente a traves del objeto del propietario actual
            System.debug('EN validateRecords mapIdAccObjAccUps: ' + mapIdAccObjAccUps.KeySet() + ' mapIdAccObjAccUps: ' + mapIdAccObjAccUps.Values());                      
            System.debug('EN validateRecords setIdCliente: ' + setIdCliente);

            //Comsulta los contactos asociados a la cuenta setIdCliente
            for (AccountContactRelation contacto : [Select id, TAM_VIN__c, ContactId, AccountId, Contact.Id, 
                    Contact.FirstName, Contact.LastName, Contact.MailingStreet, Contact.TAM_Colonia__c, 
                    Contact.MailingCity, Contact.MailingState, Contact.MailingPostalCode, Contact.Phone, 
                    Contact.Extension__c, Contact.OtherPhone, Contact.CorreoElectronico__c, Contact.Email, 
                    Contact.recordTypeId, Contact.LeadSource
                    From AccountContactRelation Where Contact.IsPersonAccount = false and Contact.LeadSource = 'Ventas'
                    and Contact.TAM_TipoCliente__c = 'Segundo' and AccountId IN :setIdCliente]){
                //Metelo al mapa de mapIdContactObjContUps
                if (!mapIdContactObjContUps.containsKey(contacto.TAM_Vin__c))
                    mapIdContactObjContUps.put(contacto.TAM_Vin__c, contacto.Contact);
            }//Fin del for para AccountContactRelation
            System.debug('EN validateRecords mapIdContactObjContUps: ' + mapIdContactObjContUps.KeySet() + ' mapIdContactObjContUps: ' + mapIdContactObjContUps.Values());
                    
            //Crea la relacion con los movimientos
            for(TAM_VehiculoPaso__c v: vehiculoList){
                                
                Integer saleCode = v.TAM_SaleCode__c != null? Integer.valueOf(v.TAM_SaleCode__c): 0;                
                Product2 prod = mapProduct2.get(v.TAM_IdModelo__c);                
                
                //Vehiculo__c vin = vines.get(v.Name);  
                Vehiculo__c vin = mapVehiculoCons.containsKey(v.Name) ? mapVehiculoCons.get(v.Name) : new Vehiculo__c();
                vin.Producto__c = prod !=null ? prod.Id : null;
                
                //Si existe el delaler en el mapa de dealers                                                                    
                if(dealers.containsKey(v.TAM_IdDealerCode__c) || Test.isRunningTest()){
                                        
                    //Crea una llave a partir del VIN, trans_Type y submitted_Time
                    String sIdExterno = v.Name + '-' + v.TAM_TransType__c + '-' + v.TAM_SubmittedTime__c;
                    String sIdModelo = v.TAM_IdModelo__c + '' + v.TAM_YearModelo__c;
                    String sSaleDate = ConvierteFechaAAAAMMDD(v.TAM_SaleDate__c);
                    Date dSaleDate = Date.valueOf(sSaleDate);
                    String sTAMSubmittedDate = ConvierteFechaAAAAMMDD(v.TAM_SubmittedDate__c);
                    Date dTAMSubmittedDate = Date.valueOf(sTAMSubmittedDate);
                    System.debug('EN validateRecords dSaleDate: ' + dSaleDate + ' dTAMSubmittedDate: ' + dTAMSubmittedDate + ' sIdExterno: ' + sIdExterno);
                                                            
                    //Agrega al mapa de  mapMovimientoUps el registro del movimiento
                    mapMovimientoUps.put(sIdExterno, new Movimiento__c(
                            Id_Externo__c = sIdExterno,                     
                            RecordTypeId = recordTypesMap.get('Movimiento__c').get('Movimiento').Id,
                    
                            VIN__c = vin.Id,
                            Distribuidor__c = dealers.containsKey(v.TAM_IdDealerCode__c) ? dealers.get(v.TAM_IdDealerCode__c).Id : null,
                            Modelo__c = mapProduct2.containsKey(sIdModelo) ? mapProduct2.get(sIdModelo).Id : null,
                            Year_Modelo__c = v.TAM_YearModelo__c,
                            Serial__c = v.TAM_Serial__c,                            
                            Trans_Type__c = v.TAM_TransType__c,
                            Factura__c = v.TAM_Factura__c,
                            Sale_Code__c = v.TAM_SaleCode__c,
                            Sale_Date__c = dSaleDate,
                            Submitted_Date__c = dTAMSubmittedDate,
                            Submitted_Time__c = v.TAM_SubmittedTime__c,
                            Sales_Manager__c = v.TAM_SalesManager__c,
                            Ls_Assesor__c = v.TAM_lsAssesor__c,
                            //Subfijo__c = v.ModelSubfijo__c,                                                       
                            //Agrega la parte de los colores                                                                                        
                            ColorExterior__c = mapColorExt.containsKey(v.TAM_IdColorExt__c.right(3)) ? mapColorExt.get(v.TAM_IdColorExt__c.right(3)).id : null,                         
                            Descr_Color_Ext__c = v.TAM_DescrColorExt__c,
                            ColorInterno__c = mapColorInt.containsKey(v.TAM_IdColorInt__c.right(2)) ? mapColorInt.get(v.TAM_IdColorInt__c.right(2)).id : null,
                            Descr_Color_Int__c = v.TAM_DescrColorInt__c, 

                            //Los datos del cliente (Account)
                            First_Name__c = mapIdAccObjAccUps.containsKey(v.Name) ? (mapIdAccObjAccUps.get(v.Name).recordTypeId == VaRtAccRegPF ? mapIdAccObjAccUps.get(v.Name).FirstName : mapIdAccObjAccUps.get(v.Name).Name) : null,
                            Last_Name__c = mapIdAccObjAccUps.containsKey(v.Name) ? (mapIdAccObjAccUps.get(v.Name).recordTypeId == VaRtAccRegPF ? mapIdAccObjAccUps.get(v.Name).LastName : mapIdAccObjAccUps.get(v.Name).Name) : null,
                            Address_1__c = mapIdAccObjAccUps.containsKey(v.Name) ? mapIdAccObjAccUps.get(v.Name).BillingStreet : null,
                            Address_2__c = mapIdAccObjAccUps.containsKey(v.Name) ? mapIdAccObjAccUps.get(v.Name).Colonia__c : null,                        
                            City__c = mapIdAccObjAccUps.containsKey(v.Name) ? mapIdAccObjAccUps.get(v.Name).BillingCity : null, 
                            State__c = mapIdAccObjAccUps.containsKey(v.Name) ? mapIdAccObjAccUps.get(v.Name).BillingState : null,
                            Zip__c = mapIdAccObjAccUps.containsKey(v.Name) ? mapIdAccObjAccUps.get(v.Name).BillingPostalCode : null,
                            Tel_Home__c = mapIdAccObjAccUps.containsKey(v.Name) ? mapIdAccObjAccUps.get(v.Name).Phone : null,
                            Tel_Work__c = mapIdAccObjAccUps.containsKey(v.Name) ? mapIdAccObjAccUps.get(v.Name).Telefono_Oficina__c : null,
                            Tel_Work_Ext__c = mapIdAccObjAccUps.containsKey(v.Name) ? mapIdAccObjAccUps.get(v.Name).Extension_Oficina__c : null, 
                            E_Mail_2__c = mapIdAccObjAccUps.containsKey(v.Name) ? mapIdAccObjAccUps.get(v.Name).Extension_Oficina__c : null,

                            //Los datos del Contacto (Contact)
                            First_Name_Add__c = mapIdContactObjContUps.containsKey(v.Name) ? mapIdContactObjContUps.get(v.Name).FirstName : null,
                            Last_Name_Add__c = mapIdContactObjContUps.containsKey(v.Name) ? mapIdContactObjContUps.get(v.Name).LastName : null,
                            Address_1_Add__c = mapIdContactObjContUps.containsKey(v.Name) ? mapIdContactObjContUps.get(v.Name).MailingStreet : null,
                            Address_2_Add__c = mapIdContactObjContUps.containsKey(v.Name) ? mapIdContactObjContUps.get(v.Name).TAM_Colonia__c : null,                        
                            City_Add__c = mapIdContactObjContUps.containsKey(v.Name) ? mapIdContactObjContUps.get(v.Name).MailingCity : null, 
                            State_Add__c = mapIdContactObjContUps.containsKey(v.Name) ? mapIdContactObjContUps.get(v.Name).MailingState : null,
                            Zip_Add__c = mapIdContactObjContUps.containsKey(v.Name) ? mapIdContactObjContUps.get(v.Name).MailingPostalCode : null,
                            Tel_Home_Add__c = mapIdContactObjContUps.containsKey(v.Name) ? mapIdContactObjContUps.get(v.Name).Phone : null,
                            Tel_Work_Add__c = mapIdContactObjContUps.containsKey(v.Name) ? mapIdContactObjContUps.get(v.Name).OtherPhone : null,
                            Tel_Work_Ext_Add__c = mapIdContactObjContUps.containsKey(v.Name) ? mapIdContactObjContUps.get(v.Name).Extension__c : null, 
                            E_Mail_Add_2__c = mapIdContactObjContUps.containsKey(v.Name) ? mapIdContactObjContUps.get(v.Name).CorreoElectronico__c : null                                                       
                        )
                    );

                }//Fin si dealers.containsKey(v.TAM_IdDealerCode__c
                
            }

            System.debug('EN validateRecords mapMovimientoUps: ' + mapMovimientoUps.KeySet() + ' mapMovimientoUps: ' + mapMovimientoUps.Values());
            //Ve si tiene algo el mapa de  mapMovimientoUps
            if (!mapMovimientoUps.isEmpty()){
                icntUpsCtes = 0;                
                List<Movimiento__c> lMovUps = mapMovimientoUps.values();
                
                /*List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lMovUps, Movimiento__c.Id_Externo__c, false);
                //Ve si hubo error
                for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
                    if (!objDtbUpsRes.isSuccess()){
                        setErroresMovVehic.add('En los Movimientos: ' + lMovUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                        System.debug('En los Movimientos: ' + lMovUps.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                    }
                    if (objDtbUpsRes.isSuccess()){
                        setSuccesMovVehic.add(objDtbUpsRes.getId());
                        System.debug('EN validateRecords objDtbUpsRes.getId() Movimiento__c: ' + objDtbUpsRes.getId());                     
                    }
                    icntUpsCtes++;  
                }//Fin del for para lDtbUpsRes
                */
                                
            }//Fin si !mapMovimientoUps.isEmpty()           
            System.debug('EN validateRecords setErroresMovVehic: ' + setErroresMovVehic + ' setSuccesMovVehic: ' + setSuccesMovVehic);          

        } catch(Exception ex){
            System.debug('Error upsert vines: ' + ex.getMessage() + ' Linea: ' + ex.getLineNumber());
        }

        //Un rollback para todo solo estamos en pruebas
        //Database.rollback(svUpsDatos);

    } catch(Exception ex){
        System.debug('Error general: ' + ex.getMessage() + ' Linea: ' + ex.getLineNumber());
    }
            
    }   

    private String ConvierteFechaFechHora(String dtFecha, String sHora){
        System.debug('Entro a ConvierteFechaFechHora dtFecha: ' + dtFecha + ' sHora: ' + sHora);
        String sFechaPaso;
        String sHoraPaso = String.valueOf(sHora);

        try{

            //Destipa la hora
            List<String> lHoraPaso = new List<String>();
            if (sHoraPaso != null){
                String sHoraPaso2 = sHoraPaso.replace('.',':');
                System.debug('Entro a ConvierteFechaFechHora sHoraPaso: ' + sHoraPaso + ' sHoraPaso2: ' + sHoraPaso2);
                lHoraPaso = sHoraPaso2.split(':'); //19.05.30.077173
                System.debug('Entro a ConvierteFechaFechHora lHoraPaso: ' + lHoraPaso.size());          
            }
    
            //Toma el parametro de dtFecha
            Time dHora = lHoraPaso.size() >= 3 ? Time.newInstance(Integer.valueOf(lHoraPaso[0]),Integer.valueOf(lHoraPaso[1]),Integer.valueOf(lHoraPaso[2]),0) : Time.newInstance(0,0,0,0);
            System.debug('Entro a ConvierteFechaFechHora dHora: ' + dHora);
                    
            String sDtFecha = ConvierteFechaAAAAMMDD(dtFecha);      
            //Crea la fecha de paso 
            Date dFechaPaso = Date.valueOf(sDtFecha); 
            DateTime dtFechaPaso = DateTime.newInstance(dFechaPaso, dHora);
    
            sFechaPaso = String.valueOf(dtFechaPaso);
            System.debug('Entro a ConvierteFechaFechHora sFechaPaso: ' + sFechaPaso);
                        
        }catch(Exception ex){
            System.debug('Error en ConvierteFechaFechHora detalle: ' + ex.getMessage() + ' Linea: ' + ex.getLineNumber());
        }
                                
        return sFechaPaso;
    }

    private String ConvierteFechaAAAAMMDD(String sFecha){
        System.debug('Entro a ConvierteFechaAAAAMMDD sFecha: ' + sFecha);
        String sFechaPaso;
        
        //Ve si tiene algo la fecha sFecha
        if (sFecha != null && sFecha != '')
            sFechaPaso = sFecha.substring(0, 10);
        System.debug('Entro a ConvierteFechaAAAAMMDD sFechaPaso: ' + sFechaPaso);
                
        return sFechaPaso;
    }

    @TestVisible    
    private String ConvierteFecha(String sFecha){
        System.debug('Entro a ConvierteFecha sFecha: ' + sFecha);
        String sFechaPaso;
        
        String sDia;
        String sMes;
        String sAnio;
        //Ve si tiene algo la fecha sFecha
        if (sFecha != null && sFecha != ''){
            sDia = sFecha.substring(0, 2);
            sDia = Integer.valueOf(sDia) < 10 ? '0' + Integer.valueOf(sDia) : sDia;
            System.debug('Entro a ConvierteFecha sDia: ' + sDia);            
            sMes = sFecha.substring(3, 5);
            sMes = Integer.valueOf(sMes) < 10 ? '0' + Integer.valueOf(sMes)  : sMes;
            System.debug('Entro a ConvierteFecha sMes: ' + sMes);                       
            sAnio = sFecha.substring(6, 10);
            System.debug('En ConvierteFecha sDia: ' + sDia + ' sMes: ' + sMes + ' sAnio: ' + sAnio);
            //Ya tienes los datos de la fecha entonces creala con el formato adecuado
            sFechaPaso = sAnio + '-' + sMes + '-' + sDia;
        }
        System.debug('Entro a ConvierteFecha sFechaPaso: ' + sFechaPaso);
                
        return sFechaPaso;
    }	    
}